 pro deproject,x,y,lat,lon,projection=projection,forward=forward

rad=57.29577545
if not keyword_set(forward) then forward=0

phi=lat/rad
lambda=lon/rad

if not keyword_set(projection) or projection eq "plane_caree" then begin
    if forward eq 1 then begin
        x=lambda
        y=phi
    endif else begin
        lambda=x
        phi=y
    endelse
endif else if projection eq "mercator" then begin
    if forward eq 1 then begin
        x=lambda
        y=alog(tan(!pi/4+phi/2))
    endif else begin
        lambda=x
        phi=2*atan(exp(y))-!pi/2
    endelse
endif else if projection eq "albers" then begin
    phi1=55./rad
    q=(1./(2.*tan(phi1)))+sin(phi1)
    f=0.6
    if forward eq 1 then begin
        r=sqrt(q-sin(phi))
        x=r*sin(f*lambda)
        y=-r*cos(f*lambda)
    endif else begin
        r2=(x^2+y^2)
        phi=asin(q-r2)
        theta=asin(0.9999*x/(sqrt(r2)))
        if (theta ge 0) then begin
            if (y ge 0) then theta=!pi-theta
        endif else begin
            if (y ge 0) then theta=-!pi-theta
        endelse
        lambda=theta/f
    endelse
endif else if projection eq "gnomonic" then begin
    if forward eq 1 then begin
        x=tan(!pi/2-phi)*cos(lambda)
        y=tan(!pi/2-phi)*sin(lambda)
    endif else begin
        lambda=atan(y/x)
        phi=!pi/2-atan(sqrt(x^2+y^2))
        if x lt 0 and y lt 0 then begin
            lambda=lambda-!pi
        endif else if x lt 0 and y gt 0 then begin
            lambda=lambda+!pi
        endif       
    endelse
endif else if projection eq "stereographic" then begin
    if forward eq 1 then begin
        x=tan(!pi/4-phi/2)*cos(lambda)
        y=tan(!pi/4-phi/2)*sin(lambda)
    endif else begin
        phi=!pi/2-2*atan(sqrt(x^2+y^2))
        lambda=atan(y/x)
        if x lt 0 and y lt 0 then begin
            lambda=lambda-!pi
        endif else if x lt 0 and y gt 0 then begin
            lambda=lambda+!pi
        endif       
    endelse
endif else if projection eq "mollweide" then begin
    if forward eq 1 then begin
        dum=sin(phi)
        a0=phi*!Pi/4.
        iter=0
        for iter=0,5 do begin
            delta=dum-(2*a0+sin(2*a0))/!Pi
            da=!Pi*delta/(2+2*cos(2*a0))
            a0=a0+da
        endfor
        x=lambda/(!pi/2)*sqrt(2.)*cos(a0)
        y=sqrt(2.)*sin(a0)
    endif else begin
        a0=asin(y/sqrt(2.))
        phi=asin((2*a0+sin(2*a0))/!Pi)
        lambda=(!pi/2)*x/sqrt(2.-(y)^2)
    endelse
endif else if projection eq "gott" then begin
    if forward eq 1 then begin
        phi1=-asin(cos(phi)*sin(lambda/2))
        lambda1=0.5*asin(sin(phi)/cos(phi1))
        theta=phi1*!Pi/4.
        dum=sin(phi1)
        iter=0
        for iter=0,5 do begin
            delta=dum-(2*theta+sin(2*theta))/!Pi
            dtheta=!Pi*delta/(2+2*cos(2*theta))
            theta=theta+dtheta
        endfor
        x=-sqrt(2.)*sin(theta)
        y=(!pi/(sqrt(2.)*2))*lambda1*cos(theta)
    endif else begin
        ; worry about the inverse later.
        phi=0
        lambda=0
    endelse
endif else if projection eq "gott-mugnolo_elliptical" then begin
    if forward eq 1 then begin
        phi1=-asin(cos(phi)*sin(lambda/2))
        lambda1=0.5*asin(sin(phi)/cos(phi1))
        theta=phi1*!Pi/4.
        dum=sin(phi1)
        iter=0
        for iter=0,8 do begin
            delta=dum-(2*theta+sin(2*theta))/!Pi
            dtheta=!Pi*delta/(2+2*cos(2*theta))
            theta=theta+dtheta
        endfor
        x=-0.728*sqrt(2.)*sin(theta)
        y=(!pi/(sqrt(2.)*2))*lambda1*cos(theta)
    endif else begin
        ; worry about the inverse later.
        phi=0
        lambda=0
    endelse
endif else if projection eq "sinusoidal" then begin
    if forward eq 1 then begin
        x=lambda*cos(phi)
        y=phi
    endif else begin
        phi=y
        lambda=x/cos(phi)
    endelse    
endif else if projection eq "gott-mugnolo" then begin
    if forward eq 1 then begin
        x=sin(0.446*(0.5*!pi-phi))*cos(lambda)
        y=sin(0.446*(0.5*!pi-phi))*sin(lambda)
    endif else begin
        lambda=atan(y/x)
        phi=0.5*!pi-(asin(sqrt(x^2+y^2)))/0.446
        if x lt 0 and y lt 0 then begin
            lambda=lambda-!pi
        endif else if x lt 0 and y gt 0 then begin
            lambda=lambda+!pi
        endif       
    endelse
endif else if projection eq "lambert_azimuthal" then begin
    if forward eq 1 then begin
        x=sin(0.5*(0.5*!pi-phi))*cos(lambda)
        y=sin(0.5*(0.5*!pi-phi))*sin(lambda)
    endif else begin
        lambda=atan(y/x)
        phi=0.5*!pi-(asin(sqrt(x^2+y^2)))/0.5
        if x lt 0 and y lt 0 then begin
            lambda=lambda-!pi
        endif else if x lt 0 and y gt 0 then begin
            lambda=lambda+!pi
        endif       
    endelse
endif else if projection eq "lambert_conic" then begin
    if forward eq 1 then begin
        x=(tan(!pi/4-phi/2.))^(1./3)*cos(lambda/3)
        y=(tan(!pi/4-phi/2.))^(1./3)*sin(lambda/3)
    endif else begin
        lambda=3*atan(y/x)
        phi=!pi/2-2*arctan((x^2+y^2)^1.5)
    endelse
endif else if projection eq "winkel-tripel" then begin
    if forward eq 1 then begin
        a=cos(phi)*cos(lambda/2.)
        idx = where(abs(a) lt 0.00001,nsmall)
        B=a/sin(a)
        if (nsmall gt 0) then begin
            B[idx]=1
        endif
        x=(lambda/!pi)+B*cos(phi)*sin(lambda/2.)
        y=0.5*(phi+B*sin(phi))
    endif else begin
        
    endelse
endif else if projection eq "winkel-tripel_times" then begin
    if forward eq 1 then begin
         a=cos(phi)*cos(lambda/2.)
        idx = where(abs(a) lt 0.00001,nsmall)
        B=a/sin(a)
        if (nsmall gt 0) then begin
            B[idx]=1
        endif
        phi1=40./rad
        x=0.5*(lambda*cos(phi1)+2*B*cos(phi)*sin(lambda/2.))
        y=0.5*(phi+B*sin(phi))
    endif
endif else if projection eq "hammer" then begin
    if forward eq 1 then begin
        x=2*sqrt(2.)*cos(phi)*sin(lambda/2.)/sqrt(1+cos(phi)*cos(lambda/2.))
        y=sqrt(2.)*sin(phi)/sqrt(1+cos(phi)*cos(lambda/2.))
    endif else begin
    endelse
endif else if projection eq "azimuthal_equidistant" then begin
    if forward eq 1 then begin
        x=(!pi/2-phi)*cos(lambda)
        y=(!pi/2-phi)*sin(lambda)
    endif else begin
        
    endelse
endif else if projection eq "gall-peters" then begin
    if forward eq 1 then begin
        x=lambda/2.
        y=sin(phi)
    endif else begin
        lambda=2*x
        phi=asin(y)
    endelse
endif else if projection eq "eckert4" then begin
    if forward eq 1 then begin
        ; compute theta
        u=(4+!pi)*sin(phi)/2.
        theta=u/4.
        for iter=0,5 do begin 
            diff=theta+sin(theta)*cos(theta)+2*sin(theta)-u
            dfdtheta=1+cos(2*theta)+2*cos(theta)
            dtheta=-diff/dfdtheta*0.9
            theta=theta+dtheta
        endfor
        x=2*lambda*(1+cos(theta))/sqrt(4*!pi+!pi^2)
        y=2*sqrt(!pi)*sin(theta)/sqrt(4+!pi)
    endif else begin
        
    endelse
endif else if projection eq "eckert6" then begin
    if forward eq 1 then begin
        ; compute theta
        u=(1+!pi/2)*sin(phi)
        theta=u/2.
        for iter=0,20 do begin 
            diff=theta*sin(theta)-u
            theta=u-sin(theta)
        endfor
        x=lambda*(1+cos(theta))/sqrt(2+!pi)
        y=2*theta/sqrt(2+!pi)
    endif else begin
    endelse
endif else if projection eq "lagrange" then begin
    if forward eq 1 then begin
        phi1=asin(tan(phi/2))
        x=4*cos(phi1)*sin(lambda/2.)/(1+cos(phi1)*cos(lambda/2.))
        y=4*sin(phi1)/(1+cos(phi1)*cos(lambda/2.))
    endif else begin
    endelse 
endif else if projection eq "briesemeister" then begin
    if forward eq 1 then begin
        x=sqrt(7.)*cos(phi)*sin(lambda/2.)/sqrt(1+cos(phi)*cos(lambda/2.))
        y=4/sqrt(7.)*sin(phi)/sqrt(1+cos(phi)*cos(lambda/2.))
    endif else begin
    endelse
endif else if projection eq "miller" then begin
    if forward eq 1 then begin
        x=lambda
        y=1.25*alog(tan(!pi/4+2*phi/5.))
    endif else begin
    endelse
endif else if projection eq "polyconic" then begin
    if forward eq 1 then begin
        x=cos(phi)/sin(phi)*sin(lambda*sin(phi))
        y=phi+cos(phi)/sin(phi)*(1-cos(lambda*sin(phi)))
    endif else begin
    endelse 
endif else if projection eq "gall_stereographic" then begin
    if forward eq 1 then begin
        x=lambda/sqrt(2.)
        y=(1+1./sqrt(2.))*tan(phi/2.)
    endif else begin
    endelse
endif else if projection eq "kav1.2" then begin
    if forward eq 1 then begin
        const=1.2 ; adapted kavrayskiy7
        x=3*lambda*sqrt(!pi^2/3.-phi^2)/(2.*!pi)
        y=const*phi
    endif else begin
    endelse
endif else if projection eq "kav1.3" then begin
    if forward eq 1 then begin
        const=1.3 ; adapted kavrayskiy7
        x=3*lambda*sqrt(!pi^2/3.-phi^2)/(2.*!pi)
        y=const*phi
    endif else begin
    endelse
endif else if projection eq "kav1.25" then begin
    if forward eq 1 then begin
        const=1.25 ; adapted kavrayskiy7
        x=3*lambda*sqrt(!pi^2/3.-phi^2)/(2.*!pi)
        y=const*phi
    endif else begin
    endelse
endif else if projection eq "kav1.1" then begin
    if forward eq 1 then begin
        const=1.1
        x=3*lambda*sqrt(!pi^2/3.-phi^2)/(2.*!pi)
        y=const*phi
    endif
endif else if projection eq "kavrayskiy7" then begin
    if forward eq 1 then begin
        const=1. ; adapted kavrayskiy7
        x=3*lambda*sqrt(!pi^2/3.-phi^2)/(2.*!pi)
        y=const*phi
    endif else begin
    endelse
endif else if projection eq "gnomonic_cube" then begin
    if forward eq 1 then begin
        x=phi*0
        y=phi*0
        x1=cos(phi)*sin(lambda)
        y1=cos(phi)*cos(lambda)
        z1=sin(phi)
        i1=where(((abs(z1) gt abs(x1)) and (abs(z1) gt abs(y1))) and (z1 gt 0),n1)
        if (n1 gt 0) then begin
            x[i1]=x1[i1]/z1[i1]
            y[i1]=2-y1[i1]/z1[i1]
        endif
        i2 =where(((abs(z1) gt abs(x1)) and (abs(z1) gt abs(y1))) and (z1 lt 0),n2)
        if (n2 gt 0) then begin
            x[i2]=-x1[i2]/z1[i2]
            y[i2]=-(y1[i2]/z1[i2])-2
        endif
        i3=where(((abs(y1) ge abs(z1)) and (abs(y1) ge abs(x1))) and (y1 ge 0),n3)
        if (n3 gt 0) then begin
            x[i3]=x1[i3]/y1[i3]
            y[i3]=z1[i3]/y1[i3]
        endif
        i4=where(((abs(y1) gt abs(z1)) and (abs(y1) gt abs(x1))) and (y1 lt 0),n4)
        if (n4 gt 0) then begin
            x[i4]=4+x1[i4]/y1[i4]
            y[i4]=-z1[i4]/y1[i4]
        endif
        i5=where(((abs(x1) gt abs(y1)) and (abs(x1) gt abs(z1))) and (x1 gt 0),n5)
        if (n5 gt 0) then begin
            x[i5]=2-y1[i5]/x1[i5]
            y[i5]=z1[i5]/x1[i5]
        endif
        i6=where(((abs(x1) gt abs(y1)) and (abs(x1) gt abs(z1))) and (x1 lt 0),n6)
        if (n6 gt 0) then begin
            x[i6]=-y1[i6]/x1[i6]-2
            y[i6]=-z1[i6]/x1[i6]
        endif
    endif else begin
        ; things inside the map need to be defined.
        lambda=x*0
        phi=x*0
        i_outside=where((x lt -3 or x gt 5) or $
                        ((x gt -3 and x lt -1) and (y gt 1 or y lt -1)) or $
                        ((x gt -1 and x lt 1) and (y gt 3 or y lt -3)) or $
                        ((x gt 1 and x lt 5) and (y gt 1 or y lt -1)),n)
        if (n gt 0) then begin
            lambda[i_outside]=-1000.
            phi[i_outside]=-1000.
        endif
        
    endelse
endif

if (forward ne 1) then begin
    lon=lambda*rad
    lat=phi*rad
endif

end
