pro map_random,projection,npts=ntps,latmax=latmax,latmin=latmin

nx=1000
ny=1000

;window,0,xsize=nx,ysize=ny

lonmin=-180
lonmax=180

if not keyword_set(latmax) then latmax=89.99
if not keyword_set(latmin) then latmin=-89.99
if not keyword_set(npts) then npts=30000

rad=57.2957

; first create an outline...
noutline=400
n4=noutline/4
lat_outline=dblarr(noutline)
lon_outline=dblarr(noutline)

for i=0,n4-1 do begin
    lat_outline[i]=latmin
    lon_outline[i]=lonmin+i/(n4-1.);*float(lonmax-lonmin)

    lat_outline[i+n4]=latmin+i/(n4-1.);*(latmax-latmin)
    lon_outline[i+n4]=lonmax

    lat_outline[i+2*n4]=latmax
    lon_outline[i+2*n4]=lonmax-i/(n4-1.);*float(lonmax-lonmin)

    lat_outline[i+3*n4]=latmax-i/(n4-1.);*(latmax-latmin)
    lon_outline[i+3*n4]=lonmin
endfor
deproject,x_outline,y_outline,lat_outline,lon_outline,projection=projection,forward=1

;plot,x_outline,y_outline,/isotropic,xstyle=4,ystyle=4,COLOR=0,BACKGROUND=-1

ds=1e-3
u1=dblarr(2)
Area=dblarr(npts)
rat=dblarr(npts)
a=dblarr(npts)
b=dblarr(npts)
s=dblarr(npts)
f=dblarr(npts)

dist=dblarr(npts)

for i=0,npts-1 do begin
    lon=360.*(randomu(seed)-0.5)
    ; Pick a random point
    ;r=2.
    ;while (r gt 1.) do begin
    ;    xdum=2.*randomu(seed)-1.
    ;    ydum=2.*randomu(seed)-1.
    ;    zdum=2.*randomu(seed)-1.
    ;    r=sqrt(xdum^2+ydum^2+zdum^2)
    ;endwhile

    ;lat=rad*asin(zdum/rad)
    

    

    lat=rad*asin(randomu(seed)*(sin(latmax/rad)-sin(latmin/rad))+sin(latmin/rad))
    lon=180*(2*randomu(seed)-1.)

    lat=lat*0.995
    lon=lon*0.995

    theta=randomu(seed)*2*!pi
    ; Pick a random direction
    dlat=ds*sin(theta)
    dlon=ds*cos(theta)/cos(lat/rad)

    ; pick another random position (for distance measures)
    lat2=rad*asin(randomu(seed)*(sin(latmax/rad)-sin(latmin/rad))+sin(latmin/rad))
    lon2=180*(2*randomu(seed)-1.)

    ; Compute the physical distance between the two points
    x1=[cos(lat/rad)*cos(lon/rad),cos(lat/rad)*sin(lon/rad),sin(lat/rad)]
    x2=[cos(lat2/rad)*cos(lon2/rad),cos(lat2/rad)*sin(lon2/rad),sin(lat2/rad)]
    dum=x1[0]*x2[0]+x1[1]*x2[1]+x1[2]*x2[2]
    dist_globe=acos(dum)


    deproject,x,y,[lat,lat+dlat],[lon,lon+dlon],projection=projection,forward=1
    deproject,x2,y2,lat2,lon2,projection=projection,forward=1

    dist_map=sqrt((x2-x[0])^2+(y2-y[0])^2)

    ;oplot,[x[0]],[y[0]],psym=4,color=0

    u1[0]=x[1]-x[0]
    u1[1]=y[1]-y[0]
    u=sqrt(u1[0]^2+u1[1]^2)
    u1=u1/u
    
    ;; Calculate the metric and the christoffel symbols
    Gam=map_christoffel(projection,lat,lon,metric=g)
    theta1=atan(2*g[1,0]/(g[1,1]-g[0,0]))/2.
    b1=1./sqrt(g[0,0]*cos(theta1)^2+g[1,1]*sin(theta1)^2-2*g[0,1]*sin(theta1)*cos(theta1))
    a1=1./sqrt(g[0,0]*sin(theta1)^2+g[1,1]*cos(theta1)^2+2*g[0,1]*sin(theta1)*cos(theta1)) 
    a[i]=a1
    b[i]=b1
    get_f_s,f1,s1,u1,Gam,g
    s[i]=s1
    f[i]=f1    

    dist[i]=dist_map/dist_globe
endfor

print,'RMS of ln(a/b)=',sqrt(mean((alog(a/b))^2))
log_ab_mean=mean(alog(a*b))
;Area=a*b/mean(a*b)
print,'Area measure=',sqrt(mean((alog(a*b)-log_ab_mean)^2))
print,'Flexion=',mean(abs(f))
print,'Skewness=',mean(abs(s))

idx=where(dist gt 0 and finite(dist) eq 1)
log_dist_mean=mean(alog(dist[idx]))
print,'Distance=',sqrt(mean((alog(dist[idx])-log_dist_mean)^2))
print,'dist_mean=',exp(log_dist_mean)

end
